//
#include <delays.h>
#include "AJo.h"

enum ADChannels
{
	CH_00 = 0b00000000,			// 0
	CH_01 = 0b00000100,			// 1
	CH_02 = 0b00001000			// 2
};

// --------------------------------------------------------------------------------------
void InitIO(void)
{
	ADCON1 |= 0x0F;                 // Default all pins to digital
	
	TRISAbits.TRISA0=1;
	TRISAbits.TRISA1=1;
	TRISAbits.TRISA2=1;

	ADCON0=0x01;
	ADCON2=0b10100110;
}

// 
void SelectADChannel(byte Channel)
{
	ADCON0 &= 0b00000001;
	ADCON0 |= Channel;

	Delay10TCYx(5);
}

//
word ReadADC(void)
{
	WORD Result;

    ADCON0bits.GO = 1;              // Start AD conversion
    while(ADCON0bits.NOT_DONE)
		;							// wait for conversion
	Result.byte0 = ADRESL;
	Result.byte1 = ADRESH;

	return Result._word;
}

//
void WorkIOut(void)
{
	byte i = 0, j = 0, Channel;
	WORD Result;



	for(; i < ChannelsNum; i++)
	{
		Result._word = 0;

		Channel = i << 2;
		SelectADChannel(Channel);

		for(j = 0; j < 4; j++)
		{
			Result._word += ReadADC();
		}

		ADCSense[i]._word = Result._word/4;
	}
}
